#ifndef FSACTIONS_H
#define FSACTIONS_H

#include "fusestructs.h"

void AddFileToFS(FileSystem* fs, char* fname);
void ListFS(FileSystem* fs);
void _ListFS_(FileSystem* fs, ino_t inodeNumber, short unsigned numtabs);
void RemoveFileFromFS(FileSystem* fs, char* fname);
int _RemoveFileFromFS_(FileSystem* fs, ino_t inodeNumber, char* fname);
void ExtractFileFromFS(FileSystem* fs, char* fname);

ino_t GetFreeInodeNumber(Inode inodes[]);
ino_t GetFreeBlockNumber(int fbl[], unsigned short size);
int FindEmptyBitPosition(int number);
int FindNextDirectory(char* fname);
int FindDirectory(Inode inode, char* directoryName);
void SetFileSystemDefaults(FileSystem* fs);
void SetupRootDirectory(FileSystem* fs);
void SetupDirectoryBlock(DirectBlock* newBlock, ino_t inode);

#endif
